var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import PropTypes from 'prop-types';
import TableBuilderPropTypes from './TableBuilderPropTypes';
import { Table, TableBody, TableHead, TableCell, TableRow } from 'cf-component-table';
import { Sortable } from '@cloudflare/cf-component-sortable';

var TableBuilder = function TableBuilder(_ref) {
  var rows = _ref.rows,
      columns = _ref.columns,
      fixedLayout = _ref.fixedLayout,
      bordered = _ref.bordered,
      rowHover = _ref.rowHover;
  return React.createElement(
    Table,
    { fixedLayout: fixedLayout, bordered: bordered },
    React.createElement(
      TableHead,
      null,
      React.createElement(
        TableRow,
        null,
        columns.map(function (_ref2, index) {
          var label = _ref2.label,
              align = _ref2.align,
              sortProps = _ref2.sortProps;
          return sortProps ? React.createElement(
            Sortable,
            _extends({ key: index }, sortProps),
            function (_ref3) {
              var props = _ref3.props,
                  Arrow = _ref3.Arrow;
              return React.createElement(
                TableCell,
                _extends({}, props, { align: align }),
                label,
                ' ',
                React.createElement(Arrow, null)
              );
            }
          ) : React.createElement(
            TableCell,
            { key: index, align: align },
            label
          );
        })
      )
    ),
    React.createElement(
      TableBody,
      null,
      rows.map(function (row, idx) {
        return React.createElement(
          TableRow,
          { key: idx, hover: rowHover },
          columns.map(function (column, index) {
            return React.createElement(
              TableCell,
              {
                key: index,
                align: column.align,
                hover: column.columnHover
              },
              column.cell(row)
            );
          })
        );
      })
    )
  );
};

TableBuilder.propTypes = {
  rows: TableBuilderPropTypes.rows.isRequired,
  columns: TableBuilderPropTypes.columns.isRequired,
  fixedLayout: PropTypes.bool,
  bordered: PropTypes.bool,
  rowHover: PropTypes.bool
};

export default TableBuilder;