'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TableBuilderPropTypes = require('./TableBuilderPropTypes');

var _TableBuilderPropTypes2 = _interopRequireDefault(_TableBuilderPropTypes);

var _cfComponentTable = require('cf-component-table');

var _cfComponentSortable = require('@cloudflare/cf-component-sortable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const TableBuilder = ({ rows, columns, fixedLayout, bordered, rowHover }) => _react2.default.createElement(
  _cfComponentTable.Table,
  { fixedLayout: fixedLayout, bordered: bordered },
  _react2.default.createElement(
    _cfComponentTable.TableHead,
    null,
    _react2.default.createElement(
      _cfComponentTable.TableRow,
      null,
      columns.map(({ label, align, sortProps }, index) => sortProps ? _react2.default.createElement(
        _cfComponentSortable.Sortable,
        _extends({ key: index }, sortProps),
        ({ props, Arrow }) => _react2.default.createElement(
          _cfComponentTable.TableCell,
          _extends({}, props, { align: align }),
          label,
          ' ',
          _react2.default.createElement(Arrow, null)
        )
      ) : _react2.default.createElement(
        _cfComponentTable.TableCell,
        { key: index, align: align },
        label
      ))
    )
  ),
  _react2.default.createElement(
    _cfComponentTable.TableBody,
    null,
    rows.map((row, idx) => _react2.default.createElement(
      _cfComponentTable.TableRow,
      { key: idx, hover: rowHover },
      columns.map((column, index) => _react2.default.createElement(
        _cfComponentTable.TableCell,
        {
          key: index,
          align: column.align,
          hover: column.columnHover
        },
        column.cell(row)
      ))
    ))
  )
);

TableBuilder.propTypes = {
  rows: _TableBuilderPropTypes2.default.rows.isRequired,
  columns: _TableBuilderPropTypes2.default.columns.isRequired,
  fixedLayout: _propTypes2.default.bool,
  bordered: _propTypes2.default.bool,
  rowHover: _propTypes2.default.bool
};

exports.default = TableBuilder;